#include "TextQuery.hpp"

ifstream& open_file(ifstream &in,const string &file)
{
    in.close();
    in.clear();
    in.open(file.c_str());
    return in;
}

void TextQuery::read_file(ifstream &in)
{
	store_file(in);
	build_map();
}

void TextQuery::store_file(ifstream &in)
{
	string textline;
	while(getline(in,textline))
		lines_of_text.push_back(textline);
}

void TextQuery::build_map()
{
	for(line_no line_num = 0;line_num != lines_of_text.size();line_num++)
	{
		istringstream line(lines_of_text[line_num]);
		string word;
		while(line >> word)
		{
			word = cleanup_str(word);
			word_map[word].insert(line_num);
		}

	}
}

void TextQuery::show_vec()
{
	vector<string>::iterator ite = lines_of_text.begin();
	while(ite != lines_of_text.end())
		cout<<*ite++<<endl;
}
void TextQuery::show_map()
{
	map< string,set<line_no> >::iterator loc = word_map.begin();
	while(loc != word_map.end())
	{
		cout<<loc->first<<"\t";
		set<line_no>::iterator it = (loc->second).begin();
		while(it != (loc->second).end())
		{
			cout<<*it + 1<<" ";
			it++;
		}
		cout<<endl;
		loc++;
	}
}

set<TextQuery::line_no> TextQuery::run_query(const string &query_word) const
{
	map< string,set<line_no> >::const_iterator loc = word_map.find(query_word);
	if( loc == word_map.end() )
		return set<line_no>();	//Ҳؿյset
	else
		return loc ->second;
}

void TextQuery::print_result(set<line_no> locs,const string &query_word)
{
	cout<<query_word<<":"<<locs.size()<<endl;
	set<line_no>::iterator it = locs.begin();
	while(it != locs.end())
	{
		cout<<"(line "<<*it+1<<") ";
		cout<<lines_of_text[*it]<<endl;
		it++;
	}
}

string TextQuery::cleanup_str(const string &word)
{
	string ret;
	for(string::const_iterator it = word.begin();it != word.end();++it)
	{
		if(!ispunct(*it))
			ret += tolower(*it);
	}
	return ret;	
}